'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _prettyBytes = require('pretty-bytes');

var _prettyBytes2 = _interopRequireDefault(_prettyBytes);

var _FileUtils = require('../FileUtils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var formatTime = function formatTime(time) {
  return new Date(time).toISOString();
};

var DirectoryListing = function (_React$Component) {
  _inherits(DirectoryListing, _React$Component);

  function DirectoryListing() {
    _classCallCheck(this, DirectoryListing);

    return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
  }

  DirectoryListing.prototype.render = function render() {
    var _props = this.props,
        dir = _props.dir,
        entries = _props.entries;


    var rows = entries.map(function (_ref, index) {
      var file = _ref.file,
          stats = _ref.stats;

      var isDir = stats.isDirectory();
      var href = file + (isDir ? '/' : '');

      return _react2.default.createElement(
        'tr',
        { key: file, className: index % 2 ? 'odd' : 'even' },
        _react2.default.createElement(
          'td',
          null,
          _react2.default.createElement(
            'a',
            { title: file, href: href },
            file
          )
        ),
        _react2.default.createElement(
          'td',
          null,
          isDir ? '-' : (0, _FileUtils.getContentType)(file)
        ),
        _react2.default.createElement(
          'td',
          null,
          isDir ? '-' : (0, _prettyBytes2.default)(stats.size)
        ),
        _react2.default.createElement(
          'td',
          null,
          isDir ? '-' : formatTime(stats.mtime)
        )
      );
    });

    if (dir !== '/') rows.unshift(_react2.default.createElement(
      'tr',
      { key: '..', className: 'odd' },
      _react2.default.createElement(
        'td',
        null,
        _react2.default.createElement(
          'a',
          { title: 'Parent directory', href: '../' },
          '..'
        )
      ),
      _react2.default.createElement(
        'td',
        null,
        '-'
      ),
      _react2.default.createElement(
        'td',
        null,
        '-'
      ),
      _react2.default.createElement(
        'td',
        null,
        '-'
      )
    ));

    return _react2.default.createElement(
      'table',
      null,
      _react2.default.createElement(
        'thead',
        null,
        _react2.default.createElement(
          'tr',
          null,
          _react2.default.createElement(
            'th',
            null,
            'Name'
          ),
          _react2.default.createElement(
            'th',
            null,
            'Type'
          ),
          _react2.default.createElement(
            'th',
            null,
            'Size'
          ),
          _react2.default.createElement(
            'th',
            null,
            'Last Modified'
          )
        )
      ),
      _react2.default.createElement(
        'tbody',
        null,
        rows
      )
    );
  };

  return DirectoryListing;
}(_react2.default.Component);

DirectoryListing.propTypes = {
  dir: _react2.default.PropTypes.string.isRequired,
  entries: _react2.default.PropTypes.array.isRequired
};
exports.default = DirectoryListing;